"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const defaultOptions = {
    useUndefinedParams: false
};
const paramsToPropsCaster = (mappings, _options) => {
    const options = Object.assign({}, defaultOptions, _options);
    return (route) => {
        const result = {};
        for (const key in mappings) {
            const mapping = mappings[key];
            const param = route.params[key];
            if (typeof mapping === "function") {
                result[key] = mapping(param);
            }
            else {
                result[key] = mapping.type(param);
            }
        }
        if (options.useUndefinedParams) {
            for (const key in route.params) {
                if (!Object.prototype.hasOwnProperty.call(result, key)) {
                    result[key] = route.params[key];
                }
            }
        }
        return result;
    };
};
exports.default = paramsToPropsCaster;
